Skip to main content
`Ctrl`+`K`

# NDDataArray

class astropy.nddata.NDDataArray(data, *args, flags=None, **kwargs)

  Bases: `NDArithmeticMixin`, `NDSlicingMixin`, `NDIOMixin`, `NDData`

  An `NDData` object with arithmetic. This class is functionally equivalent to `NDData` in astropy versions prior to 1.0.

  The key distinction from raw numpy arrays is the presence of additional metadata such as uncertainties, a mask, units, flags, and/or a coordinate system.

  See also: https://docs.astropy.org/en/stable/nddata/

  Parameters:
    data `ndarray` or `NDData`

      The actual data contained in this `NDData` object. Not that this will always be copies by reference , so you should make copy the `data` before passing it in if that’s the desired behavior.

    uncertainty `NDUncertainty`, optional

      Uncertainties on the data.

    mask numpy:array_like, optional

      Mask for the data, given as a boolean Numpy array or any object that can be converted to a boolean Numpy array with a shape matching that of the data. The values must be `False` where the data is valid and `True` when it is not (like Numpy masked arrays). If `data` is a numpy masked array, providing `mask` here will causes the mask from the masked array to be ignored.

    flags numpy:array_like or `FlagCollection`, optional

      Flags giving information about each pixel. These can be specified either as a Numpy array of any type (or an object which can be converted to a Numpy array) with a shape matching that of the data, or as a `FlagCollection` instance which has a shape matching that of the data.

    wcs `python:None`, optional

      WCS-object containing the world coordinate system for the data.

      Warning

      This is not yet defined because the discussion of how best to represent this class’s WCS system generically is still under consideration. For now just leave it as None

    meta `dict` astropy:-like `object`, optional

      Metadata for this object. “Metadata” here means all information that is included with this object but not part of any other attribute of this particular object. e.g., creation date, unique identifier, simulation parameters, exposure time, telescope name, etc.

    unit `UnitBase` instance or `python:str`, optional

      The units of the data.

  Raises:
    `ValueError`

      If the `uncertainty` or `mask` inputs cannot be broadcast (e.g., match shape) onto `data`.

  Attributes Summary

  `dtype` | `numpy.dtype` of this object's data.
  `flags` |
  `mask` | any type : Mask for the dataset, if any.
  `ndim` | integer dimensions of this object's data.
  `shape` | shape tuple of this object's data.
  `size` | integer size of this object's data.
  `uncertainty` | any type : Uncertainty in the dataset, if any.
  `unit` | `Unit` : Unit for the dataset, if any.

  Methods Summary

  `convert_unit_to`(unit[, equivalencies]) | Returns a new `NDData` object whose values have been converted to a new unit.

  Attributes Documentation

  dtype

    `numpy.dtype` of this object’s data.

  flags
  mask
  ndim

    integer dimensions of this object’s data.

  shape

    shape tuple of this object’s data.

  size

    integer size of this object’s data.

  uncertainty
  unit

  Methods Documentation

  convert_unit_to(unit, equivalencies=[])

    Returns a new `NDData` object whose values have been converted to a new unit.

    Parameters:
      unit `astropy.units.UnitBase` instance or `python:str`

        The unit to convert to.

      equivalencies `python:list` of `python:tuple`

        A list of equivalence pairs to try if the units are not directly convertible. See Equivalencies.

    Returns:
      result `NDData`

        The resulting dataset

    Raises:
      `UnitsError`

        If units are inconsistent.